# Webservices (wrap) Filters Library

## Rust Libraries Collections for webservices ([warp](https://github.com/seanmonstar/warp)) filters and routes configuration

Part of the following developments:

- [Zteron](https://rlung.librecloud.online/LibreCloud/CloudMandala#cloudmandala)

Includes applications definitions and functions for following areas:

- Authorization access to webservices routes
- Access to file webservices routes
- Reject access to webservices routes

### Criteria

In a basic application scenario this group or library collections are included together.

Updating packages or dependencies shoud be keep in sync among <u>Cargo.toml</u> declarations.

### How to use

1 - Clone or download this lib in a path, better outside of target development

2 - Get current version from <u>Cargo.toml</u>

3 - <u>For each member of</u>  of **Defs Library** one line like the one below should be included in <u>target development Cargo.toml</u> (adjust version & path) and **use** whatever is need.

```toml
app_auth_filters = { version = "0.1.0", path = "../lib/filters/app_auth_filters" }
```

To include all libraries:

```toml
app_auth_filters = { version = "0.1.0", path = "../lib/filters/app_auth_filters" }
app_file_filters = { version = "0.1.0", path = "../lib/filters/app_file_filters" }
reject_filters = { version = "0.1.0", path = "../lib/filters/reject_filters" }
```

### Structure

Each directory contains a Library dedicated to applications common needs:
Inside of each directory README.md and TODO.md files has more details.

#### app_auth_filters

An authorization library based in [Casbin](https://casbin.org/) [Rust library](https://github.com/casbin/casbin-rs) 

<pre>
app_auth_filters
├── Cargo.toml
├── README.md
├── TODO.md
└── src
    └── lib.rs
</pre>

#### app_file_filters

Dedicated to load configuration, enviroment settings, profiles, collections, etc.

<pre>
app_file_filters/
├── Cargo.toml
├── README.md
├── TODO.md
└── src
    └── lib.rs
</pre>

#### reject_filters

Define common applications errors

<pre>
reject_filters
├── Cargo.toml
├── README.md
├── TODO.md
└── src
    └── lib.rs
</pre>

## Author

- [Jesús Pérez](https://info.jesusperez.pro).

## License

MIT
